/*  libbadpenguin -- generic library for Bad Penguin development
 *
 *  Copyright (C) 1996 Antonio Gallo
 *  agx@linux.it
 *  
 *  Newer versions should be on www.badpenguin.org
 *
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

char *strtoken( char **s, char *d) {
  char *s1, *s2;
  int ls, ld;
  ld=strlen(d);
  ls=0;
  s1=*s;
  
  while ((*s)[0]!=0) {
    // check NULL field
    if ( NULL != strchr( d, (*s)[0]) ) {
      (*s)++;
      if (ls==0) return NULL;
      s2 = (char*) malloc( (ls+1) * sizeof(char) );
      strncpy( s2, s1, ls );
      s2[ls]=0;
      return s2;
    }
    // goes on
    (*s)++;
    ls++;
  }
  if (ls==0) return NULL;
  s2 = (char*) malloc( (ls+1) * sizeof(char) );
  strncpy( s2, s1, ls );
  s2[ls]=0;
  return s2;  
}

